Package com.io7m.waxmill.machines

# Class WXMBootConfigurationUEFI

java.lang.Object
com.io7m.waxmill.machines.WXMBootConfigurationUEFI

All Implemented Interfaces:
  `WXMBootConfigurationType`, `WXMBootConfigurationType.WXMBootConfigurationUEFIType`

    public final class WXMBootConfigurationUEFI
    extends java.lang.Object
    implements WXMBootConfigurationType.WXMBootConfigurationUEFIType

A boot configuration that uses UEFI.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMBootConfigurationUEFI.Builder` | Builds instances of type `WXMBootConfigurationUEFI`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMBootConfigurationType

  `WXMBootConfigurationType.Kind, WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType, WXMBootConfigurationType.WXMBootConfigurationUEFIType, WXMBootConfigurationType.WXMBootDiskAttachmentType, WXMBootConfigurationType.WXMEvaluatedBootCommandsType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationGRUBBhyveType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationUEFIType, WXMBootConfigurationType.WXMGRUBKernelInstructionsType, WXMBootConfigurationType.WXMGRUBKernelLinuxType, WXMBootConfigurationType.WXMGRUBKernelOpenBSDType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMBootConfigurationUEFI.Builder` | `builder()` | Creates a builder for `WXMBootConfigurationUEFI`.
  `java.lang.String` | `comment()` |
  `static WXMBootConfigurationUEFI` | `copyOf​(WXMBootConfigurationType.WXMBootConfigurationUEFIType instance)` | Creates an immutable copy of a `WXMBootConfigurationType.WXMBootConfigurationUEFIType` value.
  `java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment>` | `diskAttachmentMap()` |
  `java.util.List<WXMBootDiskAttachment>` | `diskAttachments()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMBootConfigurationUEFI` that have equal attribute values.
  `java.nio.file.Path` | `firmware()` |
  `int` | `hashCode()` | Computes a hash code from attributes: `diskAttachments`, `comment`, `name`, `firmware`.
  `WXMBootConfigurationName` | `name()` | The unique-within-a-virtual-machine name of the boot configuration.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMBootConfigurationUEFI` with attribute values.
  `WXMBootConfigurationUEFI` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMBootConfigurationUEFI` | `withDiskAttachments​(WXMBootDiskAttachment... elements)` | Copy the current immutable object with elements that replace the content of `diskAttachments`.
  `WXMBootConfigurationUEFI` | `withDiskAttachments​(java.lang.Iterable<? extends WXMBootDiskAttachment> elements)` | Copy the current immutable object with elements that replace the content of `diskAttachments`.
  `WXMBootConfigurationUEFI` | `withFirmware​(java.nio.file.Path value)` | Copy the current immutable object by setting a value for the `firmware` attribute.
  `WXMBootConfigurationUEFI` | `withName​(WXMBootConfigurationName value)` | Copy the current immutable object by setting a value for the `name` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMBootConfigurationType.WXMBootConfigurationUEFIType

  `checkPreconditions, kind, requiredDevices`

- ## Method Details

  - ### diskAttachments

    public java.util.List<WXMBootDiskAttachment> diskAttachments()
    Specified by:
      `diskAttachments` in interface `WXMBootConfigurationType`
    Returns:
      The disks attached to the virtual machine on boot

  - ### diskAttachmentMap

    public java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment> diskAttachmentMap()
    Specified by:
      `diskAttachmentMap` in interface `WXMBootConfigurationType`
    Returns:
      The disk attachments by device slot

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMBootConfigurationType`
    Specified by:
      `comment` in interface `WXMBootConfigurationType.WXMBootConfigurationUEFIType`
    Returns:
      The value of the `comment` attribute

  - ### name

    public WXMBootConfigurationName name()
    Description copied from interface: `WXMBootConfigurationType`
    The unique-within-a-virtual-machine name of the boot configuration.
    Specified by:
      `name` in interface `WXMBootConfigurationType`
    Specified by:
      `name` in interface `WXMBootConfigurationType.WXMBootConfigurationUEFIType`
    Returns:
      The value of the `name` attribute

  - ### firmware

    public java.nio.file.Path firmware()
    Specified by:
      `firmware` in interface `WXMBootConfigurationType.WXMBootConfigurationUEFIType`
    Returns:
      The location of the UEFI firmware to load into the machine

  - ### withDiskAttachments

    public final WXMBootConfigurationUEFI withDiskAttachments​(WXMBootDiskAttachment... elements)
    Copy the current immutable object with elements that replace the content of `diskAttachments`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withDiskAttachments

    public final WXMBootConfigurationUEFI withDiskAttachments​(java.lang.Iterable<? extends WXMBootDiskAttachment> elements)
    Copy the current immutable object with elements that replace the content of `diskAttachments`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of diskAttachments elements to set
    Returns:
      A modified copy of `this` object

  - ### withComment

    public final WXMBootConfigurationUEFI withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withName

    public final WXMBootConfigurationUEFI withName​(WXMBootConfigurationName value)
    Copy the current immutable object by setting a value for the `name` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for name
    Returns:
      A modified copy of the `this` object

  - ### withFirmware

    public final WXMBootConfigurationUEFI withFirmware​(java.nio.file.Path value)
    Copy the current immutable object by setting a value for the `firmware` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for firmware
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMBootConfigurationUEFI` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `diskAttachments`, `comment`, `name`, `firmware`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMBootConfigurationUEFI` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMBootConfigurationUEFI copyOf​(WXMBootConfigurationType.WXMBootConfigurationUEFIType instance)
    Creates an immutable copy of a `WXMBootConfigurationType.WXMBootConfigurationUEFIType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMBootConfigurationUEFI instance

  - ### builder

    public static WXMBootConfigurationUEFI.Builder builder()
    Creates a builder for `WXMBootConfigurationUEFI`.

         WXMBootConfigurationUEFI.builder()
            .addDiskAttachments|addAllDiskAttachments(WXMBootDiskAttachment) // diskAttachments elements
            .setComment(String) // optional comment
            .setName(com.io7m.waxmill.machines.WXMBootConfigurationName) // required name
            .setFirmware(java.nio.file.Path) // required firmware
            .build();

    Returns:
      A new WXMBootConfigurationUEFI builder